<?php

#define("YOUTUBE_API_KEY", "AIzaSyAcMdZMYxchhnSQQOVjtQV2NrjkR9gAdv8");
$tn_youtube_api_key = get_option("tn_youtube_api_key");
define("YOUTUBE_API_KEY", $tn_youtube_api_key);

/******************** YouTube Search in the admin ********************/

class TubeNinjaEditorButton {
    function TubeNinjaEditorButton() {
        if (is_admin() && current_user_can('edit_posts') &&
                        current_user_can('edit_pages') &&
                        get_user_option('rich_editing') == 'true' ) {
                add_filter('tiny_mce_version', array(&$this,
                                'tiny_mce_version') );

								wp_register_script( 'tn_youtube_api_key', plugins_url('js/youtube-api-key.js', __FILE__) );
								$translation_array = array(
									'YOUTUBE_API_KEY' => YOUTUBE_API_KEY
								);
								wp_localize_script( 'tn_youtube_api_key', 'data', $translation_array );
								wp_enqueue_script( 'tn_youtube_api_key' );								
								
                add_filter("mce_external_plugins", array(&$this,
                                "mce_external_plugins"));
                add_filter('mce_buttons', array(&$this, 'mce_buttons'));
								
								
								
                wp_enqueue_script('jquery');
                wp_enqueue_script('jquery-ui-widget');
                wp_enqueue_script('jquery-ui-dialog');
                wp_enqueue_script('jquery-ui-position');
                wp_enqueue_style('tn_ytsearch_css',
                plugins_url('/css/tn-ytsearch.css', __FILE__));
								wp_enqueue_style( 'wp-jquery-ui-dialog', 'jquery-ui-dialog.min' );
								wp_enqueue_script('google-api-client', 'https://apis.google.com/js/client.js?onload=googleApiClientReady');
        }
    }
    function mce_buttons($buttons) {
        array_push($buttons, "separator", "ytsearch");
        return $buttons;
    }
    function mce_external_plugins($plugin_array) {
        $plugin_array['ytsearch'] = plugins_url('/js/tn-ytsearch.js',
                                                __FILE__);
        return $plugin_array;
    }
    function tiny_mce_version($version) {
        return ++$version;
    }
}

add_action('init', 'tn_editor_button');
function tn_editor_button() {
   global $tn_editor_button;
   $tn_editor_button = new TubeNinjaEditorButton();
}

/******************* Saving YouTube videos as metadata ********************/

function tnyt_get_video_data($vid) {
    #$url = "https://gdata.youtube.com/feeds/api/videos/$vid?v=2&alt=jsonc";
    $url = "https://www.googleapis.com/youtube/v3/videos?id=$vid&key=".YOUTUBE_API_KEY."&part=snippet";
    $json = file_get_contents($url);
    return json_decode($json, true);
}

add_action('save_post', 'tnyt_save_post_meta');
function tnyt_save_post_meta($post_id) {
    if (!current_user_can('edit_post', $post_id) ||
                !array_key_exists('content', $_REQUEST) ||
                (get_post_status($post_id) != 'publish' &&
                        get_post_status($post_id) != 'post')) {
        return;
    }
    $content = $_REQUEST['content'];
    $matches = array();
    $vid_regexp = '[a-zA-Z0-9_-]+';
    $query_junk = "[^~!*()'\\[\\]]*";
    delete_post_meta($post_id, TN_YTVID_POST_META);
    if (preg_match_all(
                //'|(?:\[embed(?:\s+[^]]+)?\])?' .
                '#http://(?:www\.)?youtube\.com/watch\?' .
                $query_junk .  '(?<=[&?])v=(' . $vid_regexp . ')' . $query_junk . '#'
                //'(?:\[/embed\])?|'
                , $content, $matches, PREG_PATTERN_ORDER)) {
        foreach ($matches[1] as $vid) {
            $vid_data = tnyt_get_video_data($vid);
            #$meta = array($vid, $vid_data['data']['thumbnail']['sqDefault']);
            $meta = array($vid, $vid_data['items'][0]['snippet']['thumbnails']['default']['url']);
            add_post_meta($post_id, TN_YTVID_POST_META, $meta, false);
        }
    }
}

function tnyt_get_random_videos($n=6) {
    if ($n < 1) return array();
    global $wpdb;
    $table = $wpdb->prefix . 'postmeta';
    $mkey = TN_YTVID_POST_META;
    $sql = $wpdb->prepare(
        "select post_id, meta_value from $table where meta_key = %s", $mkey);
    $result = $wpdb->get_results($sql, ARRAY_A);
    if (count($result) <= $n) {
        $keys = array_keys($result);
    } else {
        $keys = array_rand($result, $n);
    }
    $r = array();
    foreach ($keys as $idx) {
        $meta_val = unserialize($result[$idx]['meta_value']);
        $r[] = array_merge((array)$result[$idx]['post_id'], $meta_val);
    }
    return $r;
    // too bad this is only for PHP 5.3:
    // return array_map(
    //     function ($idx) use ($result) { return $result[$idx]; }, $keys);
}

/** ******************** Random YouTube video widget ***********************/
add_action('widgets_init', 'register_ytrandom');
function register_ytrandom() {
    register_widget('RandomYTWidget');
}

class RandomYTWidget extends WP_Widget {
    function RandomYTWidget() {
        $widget_ops = array('classname' => 'RandomYTWidget',
            'description' =>
                'Displays a widget with random YouTube videos from posts' );
        $this->WP_Widget('RandomYTWidget',
                         'Random YouTube Videos', $widget_ops);
        $this->create_settings();
    }

    function create_settings() {
        $settings = $this->get_settings();
        $this->save_settings($settings);
    }

    function form($instance) {
        $instance = wp_parse_args(
                (array)$instance, array('title' => 'Random Videos',
                                        'width' => '240',
                                        'number' => '6'));
        $title = $instance['title'];
        $width = $instance['width'];
        $number = $instance['number'];
        ?>
        <p>
        <label for="<?php echo $this->get_field_id('title'); ?>">
            Title:
                <input
                    class="widefat"
                    id="<?php echo $this->get_field_id('title'); ?>"
                    name="<?php echo $this->get_field_name('title'); ?>"
                    type="text" value="<?php echo esc_attr($title); ?>" />
        </label>
        <label for="<?php echo $this->get_field_id('width'); ?>">
            Width of the sidebar (px):
                <input
                    class="widefat"
                    id="<?php echo $this->get_field_id('width'); ?>"
                    name="<?php echo $this->get_field_name('width'); ?>"
                    type="text" value="<?php echo esc_attr($width); ?>" />
        </label>
        <label for="<?php echo $this->get_field_id('number'); ?>">
            Number of videos:
                <input
                    class="widefat"
                    id="<?php echo $this->get_field_id('number'); ?>"
                    name="<?php echo $this->get_field_name('number'); ?>"
                    type="text" value="<?php echo esc_attr($number); ?>" />
        </label>
        </p>
        <?php
    }

    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = $new_instance['title'];
        $instance['width'] = $new_instance['width'];
        $instance['number'] = $new_instance['number'];
        return $instance;
    }

    function widget($args, $instance) {
        extract($args, EXTR_SKIP);

        echo $before_widget;
        $title = empty($instance['title']) ?
                ' ' : apply_filters('widget_title', $instance['title']);
        $width = empty($instance['width']) || !(int)$instance['width'] ?
                                240 : (int)$instance['width'];
        $number = empty($instance['number']) || !(int)$instance['number'] ?
                                6 : (int)$instance['number'];
        $default_width = 100; $default_height = 75;
        $margin = 4 /*2.5*/; $padding = 2;
        $items_per_row = ceil($width/$default_width);
        $item_width = ($width) / $items_per_row - 2*$margin - 2*$padding - 1;
                //floor(.9 * $width / $items_per_row);
        $item_height = $default_height * ($item_width/$default_width);
                //round($default_height * $item_width/$default_width);

        $ul_style = " style=\"list-style-type: none; white-space: nowrap; text-align: center; padding: 0; margin: 0;\"";
        // old margin/padding for lis: margin: 3px 0; padding: 0 3px 0 0;
        $li_style = " style=\"display: inline-block; padding: {$padding}px; margin: {$margin}px; border: 1px solid #ccc;\"";
        $img_style = " style=\"width: {$item_width}px; height: {$item_height}px; margin: 0; padding: 0;\"";

        if (!empty($title)) echo $before_title . $title . $after_title;

        $ytvids = tnyt_get_random_videos($number);

        echo " <ul$ul_style>";
        foreach ($ytvids as $i => $ytvid) {
            if ($i > 0 && $i % $items_per_row === 0) echo '<br />';
            $post = get_permalink($ytvid[0]);
            $title = get_the_title($ytvid[0]);
            $thumb = $ytvid[2];
            ?><li class="ytrandomitem" <?php echo $li_style; ?>><a href="<?php
                    echo $post;
                    ?>"><img src="<?php echo esc_html($thumb); ?>"
                         title="<?php echo esc_html($title); ?>"
                         <?php echo $img_style; ?> /></a></li><?php
        }
        echo '</ul>';

        echo $after_widget;
    }
}

// Disable related videos with youtube embedded videos
add_filter('oembed_result', 'tnyt_disable_related_videos', 10, 3);
function tnyt_disable_related_videos ($html, $url, $args) {
    if (isset($args['rel']) && 0 == $args['rel'] &&
        preg_match('#youtube#', $url)) {
        return preg_replace('#src="([^"]+)"#', 'src="$1&rel=0"', $html);
    }
    return $html;
}
