jQuery(function ($) {
    var $ver_b = $("h3:contains('Version B settings')").next().andSelf();
    if (!$('#tn-adbar-use_a_b').is(':checked')) {
        $ver_b.hide();
    }
    $('#tn-adbar-use_a_b').click(function () {
        if ($(this).is(":checked")) {
            $ver_b.slideDown('slow');
        } else {
            $ver_b.slideUp('slow');
        }
    });
    // farbtastic color picker
    $('.tn-color').each(function () {
        var $input = $(this).find('input'),
            $dialog = $(this).find('.tn-colorpicker-dialog'),
            $colorpicker = $(this).find('.tn-colorpicker');
        $colorpicker.farbtastic($input);
        $dialog.dialog({
            autoOpen: false,
            modal: false, //true,
            zIndex: 10000,
            dialogClass: 'wp-dialog',
        });
        $input.click(function () {
            $dialog.dialog('open');
        }).focus(function () {$(this).click()});
    });
    // font picker
    var fonts = [
        'Arial,Arial,Helvetica,sans-serif',
        '"Arial Black","Arial Black",Gadget,sans-serif',
        '"Comic Sans MS","Comic Sans MS",cursive,sans-serif',
        '"Courier New","Courier New",Courier,monospace',
        'Georgia,Georgia,serif',
        'Impact,Charcoal,sans-serif',
        '"Lucida Console",Monaco,monospace',
        '"Lucida Sans Unicode","Lucida Grande",sans-serif',
        '"Palatino Linotype","Book Antiqua",Palatino,serif',
        'Tahoma,Geneva,sans-serif',
        '"Times New Roman",Times,serif',
        '"Trebuchet MS",Helvetica,sans-serif',
        'Verdana,Geneva,sans-serif'
    ];
    // disable all font dialogs on escape and click on other places
    $(document).keypress(function (e) {
        if (27 === e.keyCode) {
            $('.tn_fontselector').slideUp('slow');
        }
    });
    $(document).click(function (e) {
        $('.tn_fontselector').slideUp('slow');
    });
    $('.tn-font-selector').each(function () {
        // create a ul to house the drop-down
        $input = $(this);
        $input.css('font-family', $input.val());
        var $ul = $('<ul class="tn_fontselector"></ul>');
        $ul.css({
            'float': 'left',
            'list-style': 'none',
            'position': 'absolute',
            'background-color': 'white',
            'font-size': '24px',
            'border': '2px solid black',
            'margin': '0px',
            'padding': '10px 0px',
            'border-radius': '5px'
        });
        $.each(fonts, function (idx, val) {
            var $li = $('<li></li>').appendTo($ul),
                display = val.split(',')[0].replace(/^"?([^"]+)"?$/,'$1'),
                $a = $('<a href="#">' + display + '</a>').appendTo($li);
            $a.css({
                'font-family': val,
                'text-decoration': 'none',
                'color': 'black',
                'display': 'block',
                'padding': '3px 10px'
            });
            $a.hover(function () {$(this).css('background-color', '#eee')},
                function () {$(this).css('background-color', 'white')});
            $a.data('tn_input', $input);
            $a.data('tn_font', val);
        });
        $('body').append($ul);
        $ul.hide();
        $(this).data('tn_fontselector', $ul);

        $(this).click(function (e) {
            var $ul = $(this).data('tn_fontselector').css({
                top: $(this).offset().top + $(this).height() + 7,
                left: $(this).offset().left,
                width: $(this).width() + 5
            }).slideDown('slow'); //.show('slow');
            return false;
        }).focus(function () {$(this).click()}).blur(function () {
            $(this).data('tn_fontselector').slideUp('slow');
        });

        $ul.find('a').click(function () {
            var $input = $(this).data('tn_input'),
                value = $(this).data('tn_font');
            $input.val(value);
            $input.css('font-family', value);
            $(this).parents('ul').slideUp('slow'); //.hide('slow');
            return false;
        });
    });
});