<?php
/**
Plugin Name: WP Tube Ninja
Plugin URI: http://www.yourdomain.com
Description: The ultimate video blog curation system!
Version: 2.0
Author: Your Name
Author URI: http://www.yourdomain.com
**/

require_once('tn-settings.php');
require_once('tn-ytsearch.php');
require_once('tn-adbar.php');
require_once('tn-admin-menu.php');
require_once('tn-linkmonetizer-list-table.php');
require_once('tn-bundling.php');

/********************** Link Monetizer admin stuff ******************/

function tnlm_increment_counter($slug, $column) { // XXX valid slug?
    global $wpdb;
    $table = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $sql = $wpdb->prepare(
        "UPDATE $table SET $column = $column + 1 WHERE slug = %s;", $slug);
    return $wpdb->query($sql);
}

function tnlm_edit_link($id, $slug, $firstlink, $secondlink) {
    global $wpdb;
    $table = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $slug = sanitize_title($slug);
    $data = array(
            'slug' => $slug,
            'firstlink' => $firstlink,
            'secondlink' => $secondlink
    );
    $where = array('id' => $id);
    return $wpdb->update($table, $data, $where, '%s', '%d');
}

function tnlm_add_link($slug, $firstlink, $secondlink) {
    global $wpdb;
    $table = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $slug = sanitize_title($slug);
    $data = array(
                    'slug' => $slug,
                    'firstlink' => $firstlink,
                    'secondlink' => $secondlink
    );
    return $wpdb->insert($table, $data);
}

function tnlm_delete_links($linkids) {
    if (!count($linkids)) return;
    global $wpdb;
    $table = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $ids = implode(',', array_fill(0, count($linkids), '%d'));
    $sql = $wpdb->prepare("DELETE from $table WHERE id in ($ids);", $linkids);
    return $wpdb->query($sql);
}

function tnlm_reset_links($linkids) {
    if (!count($linkids)) return;
    global $wpdb;
    $table = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $ids = implode(',', array_fill(0, count($linkids), '%d'));
    $sql = $wpdb->prepare(
      "UPDATE $table SET firstcount = 0, secondcount = 0 where id in ($ids);",
      $linkids);
    return $wpdb->query($sql);
}

function tnlm_get_link_data($orderby, $order) {
    global $wpdb;
    $table = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $orderby = (in_array($orderby,
        array('id', 'slug',
            'firstlink', 'secondlink', 'firstcount', 'secondcount')) ?
        $orderby : 'id');
    $order = ($order === 'desc' ? 'desc' : 'asc');
    $sql = "SELECT * FROM $table ORDER BY $orderby $order;";
    return $wpdb->get_results($sql, ARRAY_A);
}

function tnlm_get_link($slug) { // XXX not a valid slug?
    global $wpdb;
    $table = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $sql = $wpdb->prepare("SELECT * from $table where slug = %s", $slug);
    return $wpdb->get_row($sql, ARRAY_A);
}

function tnlm_admin_menu() {
    ?>
    <div>
    <h3>Link Monetizer</h3>
    <form method="post">
    <?php
    wp_nonce_field(TN_PLUGIN_FOLDER.'_nonce', TN_PLUGIN_FOLDER.'_nonce');
    tnlm_show_link_table();
    echo '</form></div>';
}

function tnlm_show_link_table() {
    $listTable = new Linkmonetizer_List_Table();
    $listTable->prepare_items();
    $listTable->display();
}

/************************** Custom link structure **********************/

add_action('template_redirect', 'tn_custom_urls');
// add_action('init', 'tn_custom_urls');
function tn_custom_urls() {
    global $wp;
    if ($row = tnlm_get_link($wp->request)) {
        tnlm_process_link($row);
        return;
    }

    $levels = explode('/', $wp->request);
    $options = get_option(TN_ADBAR_OPTION);

    if (TN_LINKMONETIZER_STAT_LINK_ROOT === $levels[0]) {
        tnlm_process_stats($levels);
        return;
    }

    if ($levels[0] !== TN_ADBAR_STAT_LINK_ROOT ||
        ($levels[1] !== 'load' && $levels[1] !== 'click') ||
        ($levels[2] !== 'version-a' && $levels[2] !== 'version-b')) {
        return;
    }
    $stats = get_option(TN_ADBAR_STATS);
    $stats[$levels[1]][$levels[2]]++;
    update_option(TN_ADBAR_STATS, $stats);

    $callback = $levels[1] === 'load' ?
                    TN_ADBAR_CALLBACK_LOAD : TN_ADBAR_CALLBACK_CLICK;
    tn_show_custom_page("$callback();", 'text/javascript');
}

function tn_show_custom_page($content, $ctype) {
    global $wp_query;
    if ($wp_query->is_404) {
        $wp_query->is_404 = false;
        $wp_query->is_archive = true;
    }
    header('HTTP/1.1 200 OK');
    header('Content-Type: '.$ctype);
    header('Cache-Control: no-cache');
    header('Expires: Fri, 29 Feb 1980 12:45:00 GMT');
    echo $content;
    exit;
}

function tnlm_process_link($row) {
    if (!$row) return;
    $firsturl = $row['firstlink'];
    $secondurl = $row['secondlink'];
    $slug = $row['slug'];
    $staturl = home_url(TN_LINKMONETIZER_STAT_LINK_ROOT . '/' . $slug);
    ob_start();
    require('tn-linkmonetizer-page.php');
    tn_show_custom_page(ob_get_clean(), 'text/html');
}

function tnlm_process_stats($levels) {
    $slug = $levels[1];
    $column = ($levels[2] === 'one') ? 'firstcount' : 'secondcount';
    tnlm_increment_counter($slug, $column);
            // nothing really to do the query fails
    tn_show_custom_page(
            TN_LINKMONETIZER_CALLBACK."();", 'text/javascript');
};

/***************** DB table for custom monetizer links ******************/

// global $tnlm_db_version;
// $tnlm_db_version = "1";

register_activation_hook(__FILE__, 'tn_install');
function tn_install() {
    tn_create_db_table();
    tn_create_default_options();
		add_option(TN_YOUTUBE_OPTION, "");
//    tn_diggdigg_initialize();
}

function tn_create_db_table() {
    global $wpdb;
//     global $tnlm_db_version;

    $table_name = $wpdb->prefix . TN_LINKMONETIZER_DBTABLE;
    $sql = <<<SQL
CREATE TABLE IF NOT EXISTS $table_name (
    id INT(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
    slug VARCHAR(256) NOT NULL,
    firstlink VARCHAR(256) NOT NULL,
    secondlink VARCHAR(256) NOT NULL,
    firstcount INT(11) NOT NULL DEFAULT 0,
    secondcount INT(11) NOT NULL DEFAULT 0
);
SQL;
		
    $result = $wpdb->query($sql);
		
		$sql = <<<SQL
ALTER TABLE `$table_name` ENGINE = MyISAM;
SQL;
		$result = $wpdb->query($sql);
		
		$sql = <<<SQL
ALTER TABLE `$table_name`
ADD UNIQUE INDEX `slug_UNIQUE` (`slug` ASC);
SQL;
		$result = $wpdb->query($sql);
		
    add_option('tnlm_db_version', TN_LINKMONETIZER_DB_VERSION);
}

global $tn_adbar_blank_stats;
$tn_adbar_blank_stats = array(
    'load' => array('version-a' => 0, 'version-b' => 0),
    'click' => array('version-a' => 0, 'version-b' => 0)
);

function tn_create_default_options($action='add') {
    global $tn_adbar_blank_stats;
    $tn_default_version_options = array(
            'font' => 'Arial,Arial,Helvetica,sans-serif',
            'size' => '18',
            'color' => '#ffffff',
            'bgcolor' => '#ff4400',
            'bordercolor' => '#ebe028',
            'message' => 'Enter your message here.',
            'linktext' => 'Put your link text here.',
            'linkurl' => 'http://www.example.com',
            'linkbgcolor' => '#000000',
            'linktextcolor' => '#ffffff'
    );
    $tn_adbar_default_settings = array(
        'a' => $tn_default_version_options,
        'b' => $tn_default_version_options,
        'use_a_b' => false,
        'show_adbar' => false
    );
    $func = "{$action}_option";
    $func(TN_ADBAR_OPTION, $tn_adbar_default_settings);
    add_option(TN_ADBAR_STATS, $tn_adbar_blank_stats);
}
